/*
 * STRUMPACK -- STRUctured Matrices PACKage, Copyright (c) 2014, The Regents of
 * the University of California, through Lawrence Berkeley National Laboratory
 * (subject to receipt of any required approvals from the U.S. Dept. of Energy).
 * All rights reserved.
 *
 * If you have questions about your rights to use or distribute this software,
 * please contact Berkeley Lab's Technology Transfer Department at TTD@lbl.gov.
 *
 * NOTICE. This software is owned by the U.S. Department of Energy. As such, the
 * U.S. Government has been granted for itself and others acting on its behalf a
 * paid-up, nonexclusive, irrevocable, worldwide license in the Software to
 * reproduce, prepare derivative works, and perform publicly and display publicly.
 * Beginning five (5) years after the date permission to assert copyright is
 * obtained from the U.S. Department of Energy, and subject to any subsequent five
 * (5) year renewals, the U.S. Government is granted for itself and others acting
 * on its behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
 * Software to reproduce, prepare derivative works, distribute copies to the
 * public, perform publicly and display publicly, and to permit others to do so.
 *
 * Developers: Francois-Henry Rouet, Xiaoye S. Li, Pieter Ghysels
 *             (Lawrence Berkeley National Lab, Computational Research Division).
 *
 */

#ifndef CONSTANTS_H
#define CONSTANTS_H

#if defined(STRUMPACK_CPP)
typedef std::complex<double> dcomplex;
#else
typedef struct dcomplex {double r; double i;} dcomplex;
#endif

#if defined(STRUMPACK_CPP)
typedef std::complex<float> scomplex;
#else
typedef struct scomplex {float r; float i;} scomplex;
#endif

/*#if defined(HQR)*/
#if 1
#define seq_XInterpol seq_HQRInterpol
#define par_XInterpol par_HQRInterpol
#else
#define seq_XInterpol seq_MGSInterpol
#define par_XInterpol par_MGSInterpol
#endif

/* Basic integer constants */
static int INONE=-1, IZERO=0, IONE=1;

/* BLACS descriptor field */
static int BLACSCTXTSIZE=9;
#define BLACSdtype 0
#define BLACSctxt  1
#define BLACSm     2
#define BLACSn     3
#define BLACSmb    4
#define BLACSnb    5
#define BLACSrsrc  6
#define BLACScsrc  7
#define BLACSlld   8

/* Node state */
enum state_name{UNTOUCHED = 0, PARTIALLY_COMPRESSED = 1, COMPRESSED = 2};

#endif // CONSTANTS_H
